#!/usr/bin/perl

# This program use for create template for testing program.
# By extract information from ladrv, lacmp and generate Ada program.
# Program name is procedure name leading wiht "t" file type adb.
#  - Add with statement.
#  - Type define variable from procedure spec.
#  - Create init statement for "in" parameter.
#  - Make call sequence.
#
# Usage:  test1 < ladrv.ads
# Wasu Chaopanon


header: while ( <STDIN> ) {

if ( /procedure/ ) {
	($p, $name, @etc ) = split;

	# file name and procedure name 
	$lp = substr($name,0,3);
	$lp1 = substr($name,0,1);

	$test_name = "t" . $name;
	$test_name =~ tr/[A-Z]/[a-z]/;
	$test_f_name = $test_name . ".adb";
	open(f_name, "> $test_f_name\0");

	# Include part
	print f_name "with Ada.Text_IO;\n"; 
	print f_name "use  Ada.Text_IO;\n";
	print f_name "with Interfaces.Fortran;\n"; 
	print f_name "use  Interfaces.Fortran;\n";
	print f_name "with labase;\n";
	print f_name "use  labase;\n";
	print f_name "with labaseio;\n"; 
	print f_name "use  labaseio;\n";
	print f_name "with ladrv;\n";
	print f_name "use  ladrv;\n";
	print f_name "\n";

	# procedure xx is
	print f_name "procedure ", $test_name, " is\n";
	print f_name "\n";
	print f_name "\tuse labaseio.Integer_IO;\n";
	if (($lp1 eq "S") | ($lp1 eq "C")) {
	  print f_name "\tuse labaseio.Real_IO;\n";
	} elsif (($lp1 eq "D") | ($lp1 eq "Z")) {
	  print f_name "\tuse labaseio.Double_Precision_IO;\n";
	};

	print f_name "\n";

	%al_p = ("","");
	@para = ();
	@in_pa = ();

	# Parameter decralation
    	pro: while ( <STDIN> ) {

	  @pp = split;
	  $p1 = $pp[0];
	  $ty = "";

	  if ($pp[2] eq "in") {
		$ty = $pp[4];
	  } elsif ($pp[2] eq "out" ) {
		$ty = $pp[3];
	  } else { 
		$ty = $pp[2];
		if ( $p1 ne "N" ) {
		  @in_pa = (@in_pa,$p1);
		};
	  };
	  
	  @para = (@para,$p1);

	  $ty =~ s/\;//;

	  $al_p{$p1} = $ty;
	  print f_name "\t", $p1, "\t : ", $ty;
	
	  if ( $p1 eq "N" ) { 
		print f_name " := 3";
	  };


	  if (/Vector/) {
	     print f_name " ( 1..";
	     print f_name "N )";
	  };

	  if (/Matrix/) {
		print f_name " ( 1..";
		print f_name "N, 1..";
		print f_name "N)";
	  };

	  print f_name ";\n";

    	  last pro if (/\)/);
	};

	print f_name "\n";

	if (($lp1 eq "S") | ($lp1 eq "C")) {
	  print f_name "\tERR : Real := 0.0;\n";
	} elsif (($lp1 eq "D") | ($lp1 eq "Z")) {
	  print f_name "\t ERR : Double_Precision := 0.0;\n";
	};
	print f_name "\n";

	print f_name "begin\n";
	
	foreach $p1 (@in_pa) {
		print f_name "\t",$p1,"\t := ;\n";
	};
	print f_name "\n";
	print f_name "\t",$name," (\n";
	$p_list = "";

	foreach $p1 (@para) {
		$p_list .=  "\t".$p1."\t => ".$p1.",\n";
	};
	chop $p_list;
	chop $p_list;
	$p_list .= ");\n";
	print f_name $p_list;

   print f_name "\n";
   print f_name "\t-- Test if error\n";
   print f_name "\tif (";
   print f_name "INFO";
   print f_name " \/= 0) then\n"; 
   print f_name "\t   Put (\"ERROR \");\n";
   print f_name "\t   Put ( INFO );\n";
   print f_name "\t   New_line;\n";
   print f_name "\tend if;\n";
   print f_name "\n";
   print f_name "\t-- Verify routine\n";
   print f_name "\n";
   print f_name "\tPUT ( \"Abs Error:\");\n";
   print f_name "\tPUT ( ERR );\n";
   print f_name "\tNew_line;\n";
   print f_name "\n";
   print f_name "end ",$test_name,";\n";
   close (f_name);

 } elsif (/Pragma/) {
    # skip 
 } else { 
    # skip
 };

};

	  